<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div
  *ngIf="selectedStepEvent && stepForm && inEditionStep"
  class="step-form-container m-3 bg-white shadow-sm">
  <div class="w-100 py-2 px-3 d-flex align-items-center justify-content-between">

    <span
      [innerText]="selectedStepEvent.action === stepEventActions.CREATION ? 'Ajout d\'une étape': 'Modification de l\'étape'"
      class="fw-bold">
    </span>

    <button
      ls-button
      [disabled]="selectedStepEvent.step.type === actions.Archive || selectedStepEvent.action === stepEventActions.CREATION"
      [style]="styles.DANGER"
      [weight]="weight.SECONDARY"
      (click)="delete()"
      [text]="commonMessages.DELETE">
    </button>

  </div>
  <hr class="m-0 p-0">

  <form [formGroup]="stepForm">
    <div class="w-100 p-3 d-flex flex-column">
      <ng-container *ngIf="selectedStepEvent.step.type !== actions.Archive">
        <h6 class="fw-bold mb-2" [innerText]="messages.STEP_TYPE_LABEL"></h6>
        <div class="mb-2 w-100 btn-group btn-group-toggle">
          <label
            *ngFor="let action of stepActions"
            [ngClass]="[stepTypeToColorClassFunction(action), inEditionStep.type.toLowerCase() === action.toLowerCase() ? 'selected' : '']"
            class="pointer btn step-type-button">
            <fa-icon [icon]="action | actionIcon: true"></fa-icon>
            <span class="ms-2" [innerText]="action | actionName"></span>
            <input
              type="radio"
              [checked]="action.toUpperCase() === inEditionStep.type"
              (change)="selectAction(action)">
          </label>
        </div>

        <h6 class="fw-bold mb-2" [innerText]="messages.VALIDATION_MODE_LABEL"></h6>

        <div class="mb-2 w-100 btn-group btn-group-toggle">
          <label
            *ngFor="let validationMode of stepValidationModes"
            [ngClass]="{'selected' : inEditionStep.validationMode === validationMode, 'disabled' : isExternalAction(inEditionStep.type) && isMultiple(validationMode)}"
            class="pointer btn validation-mode-button">
            <fa-icon [icon]="validationMode | validationModeIcon"></fa-icon>
            <span class="ms-2" [innerText]="validationMode | validationModeName"></span>
            <input
              type="radio"
              *ngIf="!(isExternalAction(inEditionStep.type) && isMultiple(validationMode))"
              [checked]="validationMode.toUpperCase() === inEditionStep.validationMode"
              (change)="selectValidationMode(validationMode)">
          </label>
        </div>
      </ng-container>

      <h6
        class="fw-bold mb-2"
        [innerText]="inEditionStep.validationMode === validationModes.Simple ? commonMessages.DESK : commonMessages.DESKS">
      </h6>

      <app-desk-search-input
        id="validatorDeskList"
        class="mb-2"
        [(desks)]="desks"
        (desksChange)="setValidators($event)"
        [multiple]="inEditionStep.validationMode !== validationModes.Simple"
        [clearable]="inEditionStep.validationMode !== validationModes.Simple"
        [genericValidatorsAvailable]="inEditionStep.validationMode === validationModes.Simple"
        [retrieveDeskFunction]="retrieveDesksAsAdminFn">
      </app-desk-search-input>

      <h6 class="fw-bold mb-2" [innerText]="messages.NOTIFIED_DESKS_LABEL"></h6>
      <app-desk-search-input
        id="notificationDeskList"
        [(desks)]="notifiedDesks"
        (desksChange)="setNotifiedValidators($event)"
        [genericValidatorsAvailable]="inEditionStep.validationMode === validationModes.Simple"
        [retrieveDeskFunction]="retrieveDesksAsAdminFn"
        [multiple]="true"
        [clearable]="true"
        [genericEmitterOnly]="true">
      </app-desk-search-input>

      <ng-container *ngIf="selectedStepEvent.step.type !== actions.Archive">

        <h6 class="fw-bold mt-2 mb-2" [innerText]="messages.MANDATORY_METADATA_VALIDATION_LABEL"></h6>
        <ng-select
          id="validationMetadata"
          bindLabel="name"
          formControlName="validationMetadata"
          class="mb-2"
          [items]="metadataList"
          (change)="setValidationMetadataList($event)"
          [searchable]="true"
          [clearable]="true"
          [multiple]="true"
          [clearOnBackspace]="true"
          [clearAllText]="commonMessages.CLEAR"
          [placeholder]="messages.SELECT_METADATA_PLACEHOLDER"
          [disabled]="metadataList.length === 0"
          [notFoundText]="commonMessages.NOT_FOUND"
          selectOnTab>
        </ng-select>


        <h6 class="fw-bold mt-2 mb-2" [innerText]="messages.MANDATORY_METADATA_REJECTION_LABEL"></h6>
        <ng-select
          id="rejectionMetadata"
          bindLabel="name"
          formControlName="rejectionMetadata"
          class="mb-2"
          [items]="metadataList"
          (change)="setRejectionMetadataList($event)"
          [clearAllText]="commonMessages.CLEAR"
          [placeholder]="messages.SELECT_METADATA_PLACEHOLDER"
          [disabled]="metadataList.length === 0"
          [notFoundText]="commonMessages.NOT_FOUND"
          [searchable]="true"
          [clearable]="true"
          [multiple]="true"
          [clearOnBackspace]="true"
          selectOnTab>
        </ng-select>
      </ng-container>
    </div>

  </form>

  <hr class="m-0 p-0">
  <div class="d-flex justify-content-end py-2 px-3">
    <button
      ls-button-cancel
      [weight]="weight.TERTIARY"
      (click)="cancel()"
      [title]="commonMessages.CANCEL">
    </button>
    <button
      ls-button-save
      [weight]="weight.SECONDARY"
      [disabled]="!stepForm?.valid"
      (click)="validateStep()"
      [title]="messages.SAVE_STEP">
    </button>
  </div>
</div>
